diff --git a/web/test/integration/daemon_health_test.rb b/web/test/integration/daemon_health_test.rb
new file mode 100644
index 000000000..4f84a5b84
--- /dev/null
+++ b/web/test/integration/daemon_health_test.rb
@@ -0,0 +1,72 @@
+require "test_helper"
+require "hive/pid_file"
+
+class DaemonHealthTest < ActionDispatch::IntegrationTest
+  include Hive::PidFile
+
+  def pid_file
+    File.join(Hive::Paths.state_home, ".daemon.pid")
+  end
+
+  def write_live_pid!
+    FileUtils.mkdir_p(File.dirname(pid_file))
+    File.write(pid_file, pid_file_payload(Process.pid).to_yaml)
+  end
+
+  teardown do
+    DaemonController.repair_runner = nil
+    FileUtils.rm_f(pid_file)
+  end
+
+  test "deep health includes the binary-consistency fields" do
+    write_live_pid!
+    get "/health", params: { deep: "1" }
+    assert_response :success
+    daemon = response.parsed_body.dig("daemon")
+    assert_equal Process.pid, daemon.dig("pid")
+    assert daemon.key?("binary_version"), "deep health must carry the daemon binary version"
+    refute_nil daemon.dig("consistent"),
+               "deep health must carry the binary-consistency verdict (true/false)"
+  end
+
+  test "repair posts the lifecycle commands through the injected runner" do
+    sign_in!(login: "alice")
+    commands = nil
+    DaemonController.repair_runner = ->(cmds) { commands = cmds }
+
+    post "/daemon/repair"
+
+    assert_redirected_to "/"
+    assert_equal 2, commands.size
+    assert_includes commands, [ commands.first.first, "daemon", "install", "--force" ]
+    assert_includes commands, [ commands.first.first, "daemon", "start" ]
+  end
+
+  test "repair renders a typed error when the bounded subprocess fails" do
+    sign_in!(login: "alice")
+    DaemonController.repair_runner = ->(_cmds) { raise Hive::Error, "daemon repair failed: boom" }
+
+    post "/daemon/repair"
+
+    assert_response :unprocessable_entity
+    assert_match(/daemon repair failed/, response.body)
+  end
+
+  test "repair is a no-op under the container supervisor" do
+    sign_in!(login: "alice")
+    commands = nil
+    DaemonController.repair_runner = ->(cmds) { commands = cmds }
+
+    prev = ENV["HIVEBOX_SUPERVISOR_PID"]
+    ENV["HIVEBOX_SUPERVISOR_PID"] = Process.pid.to_s
+    begin
+      post "/daemon/repair"
+    ensure
+      prev.nil? ? ENV.delete("HIVEBOX_SUPERVISOR_PID") : ENV["HIVEBOX_SUPERVISOR_PID"] = prev
+    end
+
+    assert_redirected_to "/"
+    assert_nil commands, "container-managed daemons must not run local lifecycle verbs"
+    assert_match(/container supervisor/, flash[:notice])
+  end
+end
diff --git a/web/test/integration/local_mode_banner_test.rb b/web/test/integration/local_mode_banner_test.rb
new file mode 100644
index 000000000..d05491e14
--- /dev/null
+++ b/web/test/integration/local_mode_banner_test.rb
@@ -0,0 +1,37 @@
+require "test_helper"
+
+# U6 — the local-mode banner must render only in loopback no-auth mode and
+# never leak into the owner-gated (Docker/hivebox) surface.
+class LocalModeBannerTest < ActionDispatch::IntegrationTest
+  def write_web_config!(auth_mode:, owner: "alice")
+    path = File.join(ENV["HIVE_HOME"], "config.yml")
+    data = File.exist?(path) ? YAML.safe_load_file(path) : {}
+    data ||= {}
+    github = { "client_id" => "client" }
+    github["owner"] = owner unless owner.to_s.strip.empty?
+    data["web"] = {
+      "bind" => "127.0.0.1",
+      "origin" => "http://127.0.0.1:4567",
+      "auth_mode" => auth_mode,
+      "unsafe_public_no_auth" => false,
+      "github" => github
+    }
+    File.write(path, data.to_yaml)
+  end
+
+  test "loopback no-auth mode shows the local-mode badge" do
+    write_web_config!(auth_mode: "loopback", owner: "")
+    get "/"
+    assert_response :success
+    assert_match(/local mode — no auth/, response.body)
+  end
+
+  test "owner mode does not show the local-mode badge" do
+    write_web_config!(auth_mode: "owner")
+    sign_in!(login: "alice")
+    get "/"
+    assert_response :success
+    refute_match(/local mode — no auth/, response.body,
+                 "the local-mode badge must be absent from the owner-gated surface")
+  end
+end
diff --git a/web/test/system/daemon_health_card_test.rb b/web/test/system/daemon_health_card_test.rb
new file mode 100644
index 000000000..c96df5510
--- /dev/null
+++ b/web/test/system/daemon_health_card_test.rb
@@ -0,0 +1,30 @@
+require "application_system_test_case"
+
+# U6 — the status page daemon health card renders the shared DaemonHealth
+# snapshot (running/version/consistent) and its Repair button posts the
+# bounded lifecycle repair. Runs under Capybara + Playwright (chromium) in CI.
+class DaemonHealthCardTest < ApplicationSystemTestCase
+  teardown do
+    DaemonController.repair_runner = nil
+  end
+
+  test "daemon card renders not-running and repairs through the bounded runner" do
+    sign_in!
+
+    # No daemon pidfile → the card shows "not running" + a Repair button.
+    visit "/"
+    assert_selector "#daemon-health", wait: 5
+    assert_selector "#daemon-health", text: "not running", wait: 5
+
+    commands = nil
+    DaemonController.repair_runner = ->(cmds) { commands = cmds }
+
+    click_button "Repair daemon"
+
+    assert_current_path "/", wait: 5
+    assert_text "Daemon repair completed", wait: 5
+    assert_equal 2, commands.size
+    assert_includes commands, [ commands.first.first, "daemon", "install", "--force" ]
+    assert_includes commands, [ commands.first.first, "daemon", "start" ]
+  end
+end
